
						window.jQuery('#term').on('change', function() {
						startCountDownTimer();
						window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');
						window.jQuery('#sectionCourseAtCampus, #sectionDataEntry').hide();
						window.jQuery('#sectionCoursesAtCampus').show();
						window.jQuery('#asideCoursesAtCampus').html('');

						window.jQuery('input[type=radio][name=action]').prop({checked: false, disabled: true});
						window.jQuery('input[type=radio][name=action]').parent().prop('class', 'controlDisabled');
						//here we now check if marks are enterable and/or viewable

						const elem = this;

						filter = structuredClone(window.jQuery(elem).data('filter'));
						filter.term = window.jQuery(elem).val();

						//we list the courses that are allocated to this examiner
						AJAXcoursesAtCampus(filter).done(function(coursesAtCampus) {
							if(Object.keys(coursesAtCampus).length > 0)
							{
								for( const[key, value] of Object.entries(coursesAtCampus))
								{
									//the following is a link to where I got the idea of wrapping code in a self executing anonymous function
									//to deal with a asynchronous call in a loop
									//https://stackoverflow.com/questions/21819905/jquery-ajax-calls-in-for-loop

									(function (filterLocal) {
										AJAXcoursesAtCampus(filterLocal).done(function(courseAtCampus) {
											window.jQuery('#asideCoursesAtCampus').append('<label class=controlDisabled ><input type=checkbox checked disabled data-course-at-campus='+courseAtCampus.course_at_campus+' /><span class=tooltip>'+courseAtCampus.nodeNAME.short+'<span class=tooltiptext >'+courseAtCampus.nodeNAME.details+'</span></span></label> ');
											if ( window.jQuery('#asideCoursesAtCampus').find('label').length === Object.keys(coursesAtCampus).length )
											{
												//start with enterable marks
												filter.regFilter = {withCompleteMarkEntry: 0};
												window.jQuery('#sectionDataEntry').hide();
												window.jQuery('#sectionCourseAtCampus').show();
												window.jQuery('#program, #electiveOption, #campus, #courseAtCampus').html('');

												const elem = this;
												filter = {target: 'RECORD_MULTI', progFilter: {cacFilter: structuredClone(filter)}};
												delete filter.progFilter.cacFilter.target;
												AJAXstations(filter).done(function(stations) {
													if(Object.keys(stations).length > 0)
													{
														window.jQuery('#station').data('filter', structuredClone(filter));
														optionsFill(stations, '#station');
													}
													else
														window.jQuery('#term').trigger('change');
												});
											}
										});
									})({target: 'RECORD_SINGLE', courseAtCampus: keyValuePairGetKey(key, value)});
								}
							}
							else
							{
								window.jQuery('#sectionCoursesAtCampus').hide();
								window.jQuery('#rubric').html('<span class=stop >There is no course allocated to you</span>');
								whatToDo(window.jQuery('#rubric'), window.jQuery('.stnNode').last().val(), 5, 0);
							}
						});
					});

					window.jQuery('#station').on('change', function(event) {
						startCountDownTimer();
						window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');

						window.jQuery('#sectionDataEntry').hide();
						window.jQuery('#electiveOption, #campus, #courseAtCampus').html('');

						const elem = this;

						filter = {target: 'RECORD_MULTI', station: window.jQuery(elem).val()};
						filter.cacFilter = structuredClone(window.jQuery(elem).data('filter').progFilter.cacFilter);

						AJAXprograms(filter).done(function(programs) {
							//possible that we are here because of 'no more students without marks in the current program'
							if(Object.keys(programs).length > 0)
							{
								window.jQuery('#program').data('filter', structuredClone(filter));
								optionsFill(programs, '#program');
							}
							else
							{
								//a problem... the filter in window.jQuery('input[type=radio][name=action]').on('click') above 'is not correct'
								//and spews stations that lead to no programs which leads to infinite loop with the following line
								//window.jQuery('input[type=radio][name=action]:checked').trigger('click');

								//so for now I opted to go back to the step that has a working filter, below
								window.jQuery('#term').trigger('change');
							}
						});
					});

					window.jQuery('#program').on('change', function() {
						startCountDownTimer();
						window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');

						window.jQuery('#sectionDataEntry').hide();
						window.jQuery('#campus, #courseAtCampus').html('');

						const elem = this;

						filter = {target: 'RECORD_MULTI', progFilter: {program: window.jQuery(elem).val()}};
						filter.cacFilter = structuredClone(window.jQuery(elem).data('filter').cacFilter);
						filter.cacFilter.program = filter.progFilter.program;

						AJAXelectiveOptions(filter).done(function(electiveOptions) {
							//possible that we are here because of 'no more students without marks in the current elective option'
							if(Object.keys(electiveOptions).length > 0)
							{
								window.jQuery('#electiveOption').data('filter', structuredClone(filter));
								optionsFill(electiveOptions, '#electiveOption');
							}
							else
								window.jQuery('#station').trigger('change');
						});
					});

					window.jQuery('#electiveOption').on('change', function() {
						startCountDownTimer();
						window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');

						window.jQuery('#sectionDataEntry').hide();
						window.jQuery('#courseAtCampus').html('');

						const elem = this;

						filter = {target: 'RECORD_MULTI', station: window.jQuery('#university').val()};
						filter.cacFilter = structuredClone(window.jQuery(elem).data('filter').cacFilter);
						filter.cacFilter.electiveOption = window.jQuery(elem).val();

						AJAXcampuses(filter).done(function(campuses) {
							//possible that we are here because of 'no more students without marks in the current campus'
							if(Object.keys(campuses).length > 0)
							{
								window.jQuery('#campus').data('filter', structuredClone(filter));
								optionsFill(campuses, '#campus');
							}
							else
								window.jQuery('#program').trigger('change');
						});
					});

					window.jQuery('#campus').on('change', function() {
						startCountDownTimer();
						window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');

						window.jQuery('#sectionDataEntry').hide();

						const elem = this;

						filter = structuredClone(window.jQuery(elem).data('filter').cacFilter);
						filter.target = 'RECORD_MULTI';
						filter.campus = window.jQuery(elem).val();
						AJAXcoursesAtCampus(filter).done(function(coursesAtCampus) {
							//possible that we are here because of 'no more students without marks in the current course at campus'
							if(Object.keys(coursesAtCampus).length > 0)
							{
								window.jQuery('#courseAtCampus').data('filter', structuredClone(filter));
								optionsFill(coursesAtCampus, '#courseAtCampus');
							}
							else
								window.jQuery('#electiveOption').trigger('change');
						});
					});

					window.jQuery('#courseAtCampus').on('change', function() {
						startCountDownTimer();
						window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');

						window.jQuery('#sectionDataEntry').show();

						const elem = this;

						filter = {target: 'RECORD_SINGLE', termester: structuredClone(window.jQuery(elem).data('filter')).termester, cacFilter: {courseAtCampus: window.jQuery(elem).val()}};
						AJAXexamStructures(filter).done(function(examStructure) {
							if ( examStructure.esFound === examStructure.yesFound )
							{
										//find out if we are landing here because of end of a mark entry
										const $entryChoices = window.jQuery('input[type=radio][name=markEntryChoice]');
										let entryIndex = -1;
										if($entryChoices.length > 0)
											entryIndex = $entryChoices.index($entryChoices.filter(':checked:enabled'));

										AJAXmarkEntryChoiceMarkup(window.jQuery('#courseAtCampus').val()).done(function(markEntryChoiceMarkup) {
											window.jQuery('#fieldsetRegisteredCourse, #fieldsetMark').hide();
											window.jQuery('#spanMarkEntryChoices').html(markEntryChoiceMarkup);

											//disable all first, to be sure the examiner cannot select a control till it is processed
											window.jQuery('input[type=radio][name=markEntryChoice]').prop('disabled', true)
											window.jQuery('input[type=radio][name=markEntryChoice]').parents('label').prop('class', 'controlDisabled');

											let processedChoices = {};

											window.jQuery('input[type=radio][name=markEntryChoice]').each(function(index, element) {

												//the following is a link to where I got the idea of wrapping code in a self executing anonymous function
												//to deal with a asynchronous call in a loop
												//https://stackoverflow.com/questions/21819905/jquery-ajax-calls-in-for-loop

												(function (radioIndex, radioElem) {
													window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');
													const parts = window.jQuery(radioElem).val().split('|');

													const examCode = parseInt(parts[0]) //parts[0] is exam type

													switch ( examCode )
													{
														case 1:
															AJAXstudentsWithoutExamResult(window.jQuery('#courseAtCampus').val(), examCode).done(function(students) {
																const studentsFound = Object.keys(students).length > 0;
																window.jQuery(radioElem).parents('label').prop('class', studentsFound ? 'controlEnabled' : 'controlDisabled');
																window.jQuery(radioElem).prop('disabled', !studentsFound);
																processedChoices[radioIndex] = 1 * studentsFound;

																if(Object.keys(processedChoices).length === window.jQuery('input[type=radio][name=markEntryChoice]').length)
																{
																	let enabledChoices = 0;
																	//https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/entries
																	Object.entries(processedChoices).forEach(([key, value]) => enabledChoices += value);
																	if ( enabledChoices === 0 ) //there are no more students without marks in this course...
																		window.jQuery('#campus').trigger('change');
																		//window.jQuery('input[type=radio][name=action]:checked').trigger('click');
																	else
																		if ( enabledChoices === 1 )
																			window.jQuery('input[type=radio][name=markEntryChoice]:enabled').trigger('click');
																		else //find out if current markEntryChoice (if any) selection still has missing marks
																			if ( entryIndex > -1 ) //see above
																			{
																				let $entryChoices = window.jQuery('input[type=radio][name=markEntryChoice]');
																				if( $entryChoices.eq(entryIndex).is(':enabled') )
																					$entryChoices.eq(entryIndex).trigger('click'); //so that we still stick with it
																				else
																					window.jQuery('#rubric').html('');
																			}
																			else
																				window.jQuery('#rubric').html('');
																}

															});
															break;
														case 0:
															const question = parseInt(parts[2]);
															AJAXstudentsWithoutExamMarksCount(window.jQuery('#courseAtCampus').val(), examCode, question).done(function(studentsCount) {
																const studentsFound = studentsCount * 1 > 0;
																window.jQuery(radioElem).parents('label').prop('class', studentsFound ? 'controlEnabled' : 'controlDisabled');
																window.jQuery(radioElem).prop('disabled', !studentsFound);
																processedChoices[radioIndex] = 1 * studentsFound;

																if(Object.keys(processedChoices).length === window.jQuery('input[type=radio][name=markEntryChoice]').length)
																{
																	let enabledChoices = 0;
																	//https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/entries
																	Object.entries(processedChoices).forEach(([key, value]) => enabledChoices += value);
																	if ( enabledChoices === 0 ) //there are no more students without marks in this course...
																		window.jQuery('#campus').trigger('change');
																		//window.jQuery('input[type=radio][name=action]:checked').trigger('click');
																	else
																		if ( enabledChoices === 1 )
																			window.jQuery('input[type=radio][name=markEntryChoice]:enabled').trigger('click');
																		else //find out if current markEntryChoice (if any) selection still has missing marks
																			if ( entryIndex > -1 ) //see above
																			{
																				let $entryChoices = window.jQuery('input[type=radio][name=markEntryChoice]');
																				if( $entryChoices.eq(entryIndex).is(':enabled') )
																					$entryChoices.eq(entryIndex).trigger('click'); //so that we still stick with it
																				else
																					window.jQuery('#rubric').html('');
																			}
																			else
																				window.jQuery('#rubric').html('');
																}

															});
															break;
													}
												}) (index, element);
											});
										});
										break;
								}
							}
							else
								window.jQuery('#rubric').html('<span class=stop >The course, <em>'+window.jQuery(elem).find('option:selected').text()+'</em> does not have an exam structure</span>');
						});
					});

					//================= mark entry commences ===============

					//Delegated event
					window.jQuery(document).on('click', 'input[type=radio][name=markEntryChoice]', function() {
						startCountDownTimer();
						window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');

						window.jQuery('#fieldsetRegisteredCourse').show();
						window.jQuery('#registeredCourse').prop('disabled', true);
						window.jQuery('#fieldsetMark').hide();

						const parts = window.jQuery(this).val().split('|');
						const question = parseInt(parts[0]) === 0 ? parts[2] : 0; //parts[0] is exam type

						AJAXstudentsWithoutMarksLegend(window.jQuery('#courseAtCampus').val(), question).done(function(marksLegend) {
							window.jQuery('#legendRegisteredCourse').html(marksLegend);
							AJAXstudentsWithoutMarks(window.jQuery('#courseAtCampus').val(), question).done(function(students) {
								window.jQuery('#registeredCourse').prop('disabled', false);
								optionsFill(students, '#registeredCourse', false);
							});
						});
					});

					window.jQuery('#registeredCourse').on('change', function() {
						startCountDownTimer();
						window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');

						window.jQuery('#fieldsetMark').show();
						window.jQuery('#buttonPost').prop('disabled', true);
						AJAXstudentMarkEntryGrid(window.jQuery('input[type=radio][name=markEntryChoice]:checked').val(), window.jQuery('#registeredCourse').val()).done(function(markEntryGrid) {
							window.jQuery('#mark_entry_legend').html(markEntryGrid.header);
							window.jQuery('#marks_matrix').html(markEntryGrid.grid);
							if(parseInt(window.jQuery('#spanMarkEntryChoices input[type=radio][name=markEntryChoice]:checked').val().split('|')[0]) === 0)
							 	window.jQuery('#labelFewerQuestions').hide()
							else
							 {
								 window.jQuery('#labelFewerQuestions').show();
								 window.jQuery('#inputFewerQuestions').prop('checked', false);
							 }
							//document.getElementsByClassName('actual_mark')[markEntryGrid.focus].focus();
							window.jQuery('.actual_mark').eq([markEntryGrid.focus]).focus();
							window.jQuery('#rubric').html('');
						});

					});

					//the code that follow checks if the marks as entered can be posted.
					//if so, it enables the post button
					//Delegated event
					//code from https://stackoverflow.com/questions/29118178/input-jquery-get-old-value-before-onchange-and-get-value-after-on-change

					window.jQuery(document).on('keydown', '.actual_mark', function(event){ //<< in future used 'beforeinput' event
						startCountDownTimer();

						let keyPressed = event.key;
						//https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/code
						switch(keyPressed)
						{
							case 'Enter':
								if(window.jQuery('#buttonPost').is(':enabled'))
									window.jQuery('#buttonPost').trigger('click');
								break;

							default:
								switch(keyPressed)
								{
									//case '-':
										//window.jQuery(this).data('keyPressedIsValid', false );
										//break;
									case '.':
										if(String(window.jQuery(this).val()).includes(keyPressed))
											window.jQuery(this).data('keyPressedIsValid', false );
										else
											if(window.jQuery(this).val() === '')
												window.jQuery(this).val('0.');
										break;
									case 'Backspace':
									case 'Delete':
										window.jQuery(this).data('keyPressedIsValid', true);
										break;
									default:
										window.jQuery(this).data('keyPressedIsValid', window.jQuery.isNumeric(keyPressed));
										break;
								}
								break;
						}
							window.jQuery(this).data('valuePrev', window.jQuery(this).val());

					}).on('input', '.actual_mark', function() {
						startCountDownTimer();

						window.jQuery('#labelFewerQuestions').hide();
						if( window.jQuery(this).data('keyPressedIsValid') )
						{
							//is value greater than max?
							let index = window.jQuery('.actual_mark').index(this);
							if(parseFloat(window.jQuery(this).val()) > parseFloat(window.jQuery('.max_mark').eq(index).val()))
								window.jQuery(this).val(window.jQuery(this).data('valuePrev'));
						}
						else
						{
							window.jQuery(this).val(window.jQuery(this).data('valuePrev'));
							window.jQuery(this).data('keyPressedIsValid', true);
							window.jQuery(this).trigger('input');
						}

						//now check if all marks have been entered and enable the posting button or clear this entry
						switch(parseInt(window.jQuery('input[type=radio][name=markEntryChoice]:checked').val().split('|')[0]))
						{
							case 0: //CATs
								window.jQuery(this).data('valuePrev', window.jQuery(this).val());
								window.jQuery('#buttonPost').prop('disabled', !window.jQuery.isNumeric(window.jQuery(this).val()));
								break;

							default:
								//count the mark entries
								let marksCount = 0;
								window.jQuery('.actual_mark').each(function(index, element) {
									if(window.jQuery.isNumeric(window.jQuery(this).val()))
										++marksCount;
								});

								const maxNumberOfQuestions = parseInt(window.jQuery('input[type=radio][name=markEntryChoice]:checked').val().split('|')[2]);

								//this prevents excess entry
								if(marksCount > maxNumberOfQuestions)
								{
									window.jQuery(this).val('');
									--marksCount;
								}

								//this prevents excess non compulsory
								const totalCompulsorySlots = window.jQuery('.compulsory:checked').length;
								let blankCompulsorySlots = totalCompulsorySlots;
								let firstBlankCompulsorySlotIndex = -1;
								let nonCompulsoryEntries = 0;
								window.jQuery('.actual_mark').each(function(index, element) {
									if ( window.jQuery.isNumeric(window.jQuery(this).val()) )
										if ( window.jQuery('.compulsory').eq(index).is(':checked') )
											--blankCompulsorySlots;
										else
											++nonCompulsoryEntries;
									else
										if ( window.jQuery('.compulsory').eq(index).is(':checked') )
											if ( firstBlankCompulsorySlotIndex === -1 )
												firstBlankCompulsorySlotIndex = index;
								});

								if ( nonCompulsoryEntries + totalCompulsorySlots > maxNumberOfQuestions )
								{
									window.jQuery('.actual_mark').eq(firstBlankCompulsorySlotIndex).focus();
									window.jQuery(this).val('');
									--marksCount;
								}

								//marksPostable
								window.jQuery('#buttonPost').prop('disabled', marksCount < maxNumberOfQuestions || blankCompulsorySlots);
								if ( window.jQuery('#buttonPost').is(':enabled') )
									window.jQuery('#labelFewerQuestions').hide();
								else
								{
									window.jQuery('#labelFewerQuestions').show();
									window.jQuery('#inputFewerQuestions').prop('checked', false);
								}
								break;
						}
					});

					window.jQuery('#inputFewerQuestions').on('click', function() {
						startCountDownTimer();

						let compulsoryIndex = window.jQuery('.compulsory').index(window.jQuery('.compulsory:checked'));
						if(window.jQuery('.actual_mark').eq(compulsoryIndex).val() === '')
							window.jQuery('.actual_mark').eq(compulsoryIndex).val(0);

						const maxNumberOfQuestions = parseInt(window.jQuery('input[type=radio][name=markEntryChoice]:checked').val().split('|')[2]);
						const $actualMarks = window.jQuery('.actual_mark');

						while (lessStill(maxNumberOfQuestions, $actualMarks))
						{
							const $compulsory = window.jQuery('.compulsory');
							const $maxMarks = window.jQuery('.max_mark');

							const index = largestVacant($maxMarks, $compulsory, $actualMarks);
							if(index > -1)
								$actualMarks.eq(index).val(0);
						}
						window.jQuery('#labelFewerQuestions').hide();
						window.jQuery('#buttonPost').prop('disabled', false);

					});

					window.jQuery('#buttonPost').on('click', function() {
						startCountDownTimer();
						if(confirm('You are sure you want to post this mark entry?'))
						{
							window.jQuery('#rubric').html('<span class=warning >Please wait...</span>');
							let dataPartial = {registered_course: window.jQuery('#registeredCourse').val()};
							dataPartial.exam_code = parseInt(window.jQuery('#spanMarkEntryChoices input[type=radio][name=markEntryChoice]:checked').val().split('|')[0]);
							let questionMarksCollection = {}, questionMarks = {};
							switch(dataPartial.exam_code)
							{
								case 0:
									dataPartial.last_question = window.jQuery('#spanMarkEntryChoices input[type=radio][name=markEntryChoice]:checked').val().split('|')[1];
									questionMarks.question = window.jQuery('#spanMarkEntryChoices input[type=radio][name=markEntryChoice]:checked').val().split('|')[2];
									questionMarks.marks = window.jQuery('.actual_mark').eq(mark.question-1).val();
									questionMarksCollection[questionMarksCollection.length] = JSON.stringify(questionMarks);
									break;
								case 1:
									dataPartial.last_question = window.jQuery('#spanMarkEntryChoices input[type=radio][name=markEntryChoice]:checked').val().split('|')[2];
									marksArray = [];
									window.jQuery('.actual_mark').each(function(index, element) {
										if(window.jQuery.isNumeric(window.jQuery(this).val()))
											questionMarksCollection[questionMarksCollection.length] = JSON.stringify({question: index + 1, marks: window.jQuery(this).val()});
									});
									break;
							}

							AJAXcreateMarkEntry(dataPartial, questionMarksCollection).done(function(verdict) {
								if(verdict.status === verdict.OK)
								{
									if ( window.jQuery('input[type=radio][name=action]').eq(1).is(':disabled') )
									{
										window.jQuery('input[type=radio][name=action]').eq(1).prop('disabled', false);
										window.jQuery('input[type=radio][name=action]').eq(1).parent().prop('class', 'controlEnabled');
										window.jQuery('#info2').html('');
									}
									window.jQuery('#courseAtCampus').trigger('change');
								}
								verdictShow(verdict);
							});
						}
					});
			});

			function lessStill(missingQuestions, $actualMarks)
			{
				$actualMarks.each(function(index, element) {
					if(window.jQuery.isNumeric($actualMarks.eq(index).val()))	missingQuestions--;
				});
				return missingQuestions;
			}

			function largestVacant($maxMarks, $compulsory, $actualMarks)
			{
				let largestMaxIndex = -1;
				let largestVacantMax = 0;
				$actualMarks.each(function(index, element) {
					if($actualMarks.eq(index).val() === '')
						if($compulsory.eq(index).prop('checked') === false) //not compulsory
							if ($maxMarks.eq(index).val() > largestVacantMax)
							{
								largestVacantMax = $maxMarks.eq(index).val();
								largestMaxIndex = index;
							}
				});
				return largestMaxIndex;
			}

		</script>
	</head>
	<body>
		<header> <?php echo session()->get('viewHeadLocal'); ?> </header>
		<aside>
			<!-- this is the popup for deleting CAt marks -->
			<section hidden id=sectionCATsDelete title='Deletion of CAT marks...' >
				<fieldset>
					<legend >The CATs to delete</legend>
					<div id=divCATsDelete ></div>
				</fieldset>
				<button type=button id=buttonCATsDelete > Delete... </button>
				<br /> <span id=spanCATsDelete ></span>
			</section>
		</aside>
		<h1><?php echo $pageAbout; ?></h1>
		<section id=sectionStation hidden >
			<fieldset>
				<legend>Step 1. Your Station</legend>
				<table>
					<tr><td class=label >University</td><td> <select class=stnNode id=university ></select> </td></tr>
					<tr><td class=label >College</td><td><select class=stnNode id=college ></select></td></tr>
					<tr><td class=label >School</td><td><select class=stnNode id=school ></select></td></tr>
					<tr><td class=label >Department</td><td><select class=stnNode id=department ></select></td></tr>
				</table>
			</fieldset>
		</section>

		<section id=sectionExaminer hidden >
			<fieldset>
				<legend>Step 1. Examiner</legend>
				<select id=examiner ></select>
			</fieldset>
		</section>

		<section id=sectionStartChoice hidden >
			<fieldset>
				<legend>Step 1. Start via...</legend>
				<label> <input type=radio name=startChoice value=0 /> Session </label>
				<label> <input type=radio name=startChoice value=1 /> Cohort </label>
			</fieldset>
		</section>

		<section id=sectionTheStart hidden >
			<fieldset>
				<legend></legend>
				<select> </select> <span id=info0 ></span>
			</fieldset>
		</section>

		<section id=sectionFilter hidden >
			<fieldset>
				<legend>Step 3. Filter</legend>
				<table>
					<tr id=trTermesterOrCohort > <td class=label >Cohort</td> <td><select></select> <span id=info1 ></span> </td> </tr>
					<tr> <td class=label >Year of study</td> <td> <select id=yos ></select> </td> </tr>
					<tr> <td class=label >Term</td> <td><select id=term ></select></td></tr>
				</table>
			</fieldset>
		</section>

		<section class=afterFilter id=sectionCoursesAtCampus hidden >
			<fieldset>
				<legend>Step 4. Courses allocated to you...</legend>
					<aside id=asideCoursesAtCampus ></aside>
			</fieldset>
		</section>

		<section class=afterFilter id=sectionCourseAtCampus hidden >
			<fieldset>
				<legend>Step 5. The Client Course </legend>
				<table>
					<tr> <td class=label >Station</td><td><select id=station ></select></td>	</tr>
					<tr> <td class=label >Program</td>	<td><select id=program ></select></td> </tr>
					<tr> <td class=label >Elective Option</td> <td> <select id=electiveOption ></select> </td> </tr>
					<tr> <td class=label >Campus</td> <td> <select id=campus ></select> </td> </tr>
					<tr> <td class=label >Course</td> <td> <select id=courseAtCampus ></select> </td> </tr>
				</table>
			</fieldset>
		</section>

		<section class=afterFilter id=sectionDataEntry hidden >
			<fieldset>
				<legend>Step 6. Mark Entry for...</legend>
				<span id=spanMarkEntryChoices ></span>
			</fieldset>
			<fieldset id=fieldsetRegisteredCourse hidden >
				<legend id=legendRegisteredCourse ></legend>
				<select id=registeredCourse ></select>
			</fieldset>
			<fieldset id=fieldsetMark hidden >
				<legend id=mark_entry_legend ></legend>
				<table style='border:1px solid green' id=marks_matrix ></table>
				<p class=approval id=labelFewerQuestions >
					<input id=inputFewerQuestions type=checkbox />
					this candidate answered fewer questions than the required
				</p>
				<button id=buttonPost type=button > Submit Mark </button>
			</fieldset>
		</section>
<!-- below here is the end of body that is padded by the controller-->
